<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: WAPPunch.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
$enable_wap = TRUE;
require_once('../../includes/global.inc.php');

//Debug::setVerbosity(11);

require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('punch','enabled')
		OR !( $permission->Check('punch','punch_in_out') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'data'
												) ) );

if ( isset($data) ) {
	$data['punch_full_time_stamp'] = $data['time_stamp'];
}

$pcf = new PunchControlFactory();
$pf = new PunchFactory();

$action = strtolower($action);
switch ($action) {
	case 'submit':
		//var_dump($data);
		//echo "User ID: ". $data['user_id'] ."<br>\n";
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$pf->StartTransaction();

		//Force In punch on transfer
		if ( isset($data['transfer']) AND $data['transfer'] == 1 ) {
			$data['status_id'] = 10;
		}

		if ( isset($data['status_id']) AND $data['status_id'] == 20 ) { //Out
			$pcf->setId( $data['punch_control_id'] );
		} else {
			$data['status_id'] = 10; // In
		}

		if ( $data['user_date_id'] == '' ) {
			$pcf->findUserDate( $data['user_id'], $data['punch_full_time_stamp'] );
		} else {
			$pcf->setUserDateID( $data['user_date_id'] );
		}

		$user_date_id = $pcf->getUserDateID();

		$pcf->setBranch( $data['branch_id'] );
		$pcf->setDepartment( $data['department_id'] );
		if ( isset($data['job_id']) ) {
			$pcf->setJob( $data['job_id'] );
		}
		if ( isset($data['job_item_id']) ) {
			$pcf->setJobItem( $data['job_item_id'] );
		}
		if ( isset($data['quantity']) ) {
			$pcf->setQuantity( $data['quantity'] );
		}
		if ( isset($data['bad_quantity']) ) {
			$pcf->setBadQuantity( $data['bad_quantity'] );
		}


		if ( $pcf->isValid() ) {
			$punch_control_id = $pcf->Save();

			//If its an update, not a new insert
			if ( $punch_control_id === TRUE ) {
				Debug::Text(' Updating Punch Control Object', __FILE__, __LINE__, __METHOD__,10);
				$punch_control_id = $data['punch_control_id'];
			}
			Debug::Text(' Punch Control ID: '. $punch_control_id, __FILE__, __LINE__, __METHOD__,10);

			if ( isset($data['transfer']) AND $data['transfer'] == 1 ) {
				$pf->setTransfer( TRUE );
			}
			$pf->setPunchControlID( $punch_control_id );
			$pf->setType( $data['type_id'] );
			$pf->setStatus( $data['status_id'] );
			$pf->setTimeStamp( $data['punch_full_time_stamp'] );
			$pf->setStation( $current_station->getID() );

			if ( $pf->isNew() ) {
				$pf->setActualTimeStamp( $data['punch_full_time_stamp'] );
				$pf->setOriginalTimeStamp( $pf->getTimeStamp() );
			}

			if ( $pf->isValid() ) {
				$return_date = $pf->getTimeStamp();
				if ( $pf->getStatus() == 10 ) {
					$label = 'In';
				} else {
					$label = 'Out';
				}

				$pf->setEnableCalcTotalTime( TRUE );
				$pf->setEnableCalcSystemTotalTime( TRUE );
				$pf->setEnableCalcUserDateTotal( TRUE );
				$pf->setEnableCalcException( FALSE ); //Do this in a cronjob at the end of the day.

				$pf->Save();

				$pf->CommitTransaction();
				//$pf->FailTransaction();

				$result = 'success';
				//Redirect::Page( URLBuilder::getURL( NULL, '../CloseWindow.php') );
				//break;

				//Get user prefs for dates.
				Debug::text('Return Date: '. $return_date, __FILE__, __LINE__, __METHOD__, 10);
				$result_str = '<p>'. $current_user->getFullName() .'</p><p>Punch '. $label .': '. TTDate::getDate('TIME', $return_date) .'</p>';

				Debug::text('Result String: '. $result_str, __FILE__, __LINE__, __METHOD__, 10);

			} else {
				//var_dump($pf);
				$result = 'fail';
			}



			break;
		}

		$pf->FailTransaction();

	default:

		$blf = new BranchListFactory();
		$branch_options = $blf->getByCompanyIdArray( $current_company->getId() );

		$dlf = new DepartmentListFactory();
		$department_options = $dlf->getByCompanyIdArray( $current_company->getId() );

		$job_options = array();
		$job_item_options = array();
		if ( $current_company->getProductEdition() == 20 ) {
			$jlf = new JobListFactory();
			$job_options = $jlf->getByCompanyIdAndUserIdAndStatusArray( $current_company->getId(),  $current_user->getId(), array(10), TRUE );

			$jilf = new JobItemListFactory();
			$job_item_options = $jilf->getByCompanyIdArray( $current_company->getId(), TRUE );
		}

		$epoch = TTDate::getTime();

		$slf = new ScheduleListFactory();

		//Get last punch for this day, for this user.
		$plf = new PunchListFactory();
		$plf->getPreviousPunchByUserIDAndEpoch( $current_user->getId(), $epoch );
		if ($plf->getRecordCount() > 0 ) {
			Debug::Text(' Found Previous Punch within Continuous Time from now: ', __FILE__, __LINE__, __METHOD__,10);
			$prev_punch_obj = $plf->getCurrent();

			$branch_id = $prev_punch_obj->getPunchControlObject()->getBranch();
			$department_id = $prev_punch_obj->getPunchControlObject()->getDepartment();

			if ( $branch_id == '' OR empty($branch_id) OR $department_id == '' OR empty($department_id) ) {
				Debug::Text(' Branch or department are null. ', __FILE__, __LINE__, __METHOD__,10);

				$s_obj = $slf->getScheduleObjectByUserIdAndEpoch( $current_user->getId(), $epoch );

				if ( is_object($s_obj) ) {
					Debug::Text(' Found Schedule!: ', __FILE__, __LINE__, __METHOD__,10);

					if ( $branch_id == '' OR empty($branch_id) ) {
						Debug::Text(' overrriding branch: '. $s_obj->getBranch(), __FILE__, __LINE__, __METHOD__,10);
						$branch_id = $s_obj->getBranch();
					}
					if ( $department_id == '' OR empty($department_id) ) {
						Debug::Text(' overrriding department: '. $s_obj->getDepartment(), __FILE__, __LINE__, __METHOD__,10);
						$department_id = $s_obj->getDepartment();
					}
				}
			}

			$next_type = $prev_punch_obj->getNextType();

			//CHeck for meal policy window.
			$prev_punch_obj->setScheduleID( $epoch );
			if ( is_object( $prev_punch_obj->getScheduleObject() )
					AND is_object( $prev_punch_obj->getScheduleObject()->getSchedulePolicyObject() )
					AND is_object($prev_punch_obj->getScheduleObject()->getSchedulePolicyObject()->getMealPolicyObject() ) ) {
				Debug::Text(' Found Schedule Meal Policy Object: Start Window: '. $prev_punch_obj->getScheduleObject()->getSchedulePolicyObject()->getMealPolicyObject()->getStartWindow(), __FILE__, __LINE__, __METHOD__,10);

				if ( $epoch >= ($prev_punch_obj->getScheduleObject()->getStartTime() + $prev_punch_obj->getScheduleObject()->getSchedulePolicyObject()->getMealPolicyObject()->getStartWindow() )
						AND $epoch <= ($prev_punch_obj->getScheduleObject()->getStartTime() + $prev_punch_obj->getScheduleObject()->getSchedulePolicyObject()->getMealPolicyObject()->getStartWindow() + $prev_punch_obj->getScheduleObject()->getSchedulePolicyObject()->getMealPolicyObject()->getWindowLength() ) ) {
					Debug::Text(' Setting Type to Lunch: ', __FILE__, __LINE__, __METHOD__,10);
					$next_type = 20;
				}
			} elseif ( is_object($prev_punch_obj) AND $prev_punch_obj->getType() != 20 ) {
				//Check NON-scheduled meal policies
				$mplf = new MealPolicyListFactory();
				$mplf->getByPolicyGroupUserId( $current_user->getId() );
				if ( $mplf->getRecordCount() > 0 ) {
					$mp_obj = $mplf->getCurrent();
					Debug::Text(' Found NON Schedule Meal Policy start Window: '. $mp_obj->getStartWindow(), __FILE__, __LINE__, __METHOD__,10);

					if ( $epoch >= ($prev_punch_obj->getTimeStamp() + $mp_obj->getStartWindow())
							AND $epoch <= ($prev_punch_obj->getTimeStamp() + $mp_obj->getStartWindow() + $mp_obj->getWindowLength() ) ) {
						Debug::Text(' Setting Type to Lunch: ', __FILE__, __LINE__, __METHOD__,10);
						$next_type = 20;
					}
				} else {
					Debug::Text(' DID NOT Find NON Schedule Meal Policy start Window: ', __FILE__, __LINE__, __METHOD__,10);
				}
				unset($mplf, $mp_obj);
			}

			$data = array(
							'user_id' => $current_user->getId(),
							'user_full_name' => $current_user->getFullName(),
							'time_stamp' => $epoch,
							'date_stamp' => $epoch,
							'branch_id' => $branch_id,
							'department_id' => $department_id,
							'job_id' => $prev_punch_obj->getPunchControlObject()->getJob(),
							'job_item_id' => $prev_punch_obj->getPunchControlObject()->getJobItem(),
							'quantity' => (float)$prev_punch_obj->getPunchControlObject()->getQuantity(),
							'bad_quantity' => (float)$prev_punch_obj->getPunchControlObject()->getBadQuantity(),
							'status_id' => $prev_punch_obj->getNextStatus(),
							'type_id' => $next_type,
							'punch_control_id' => $prev_punch_obj->getNextPunchControlID(),
							'user_date_id' => $prev_punch_obj->getPunchControlObject()->getUserDateID(),
							'selected_type_option' => (int)Misc::getPointerFromArray( $pf->getOptions('type'), $next_type ),
							'selected_status_option' => (int)Misc::getPointerFromArray( $pf->getOptions('status'), $prev_punch_obj->getNextStatus() ),
							'selected_branch_option' => (int)Misc::getPointerFromArray( $branch_options, $branch_id ),
							'selected_department_option' => (int)Misc::getPointerFromArray( $department_options, $department_id ),
							'selected_job_option' => (int)Misc::getPointerFromArray( $job_options, $prev_punch_obj->getPunchControlObject()->getJob() ),
							'selected_job_item_option' => (int)Misc::getPointerFromArray( $job_item_options, $prev_punch_obj->getPunchControlObject()->getJobItem() ),
							);

		} else {
			Debug::Text(' DID NOT Find Previous Punch within Continuous Time from now: ', __FILE__, __LINE__, __METHOD__,10);
			$branch_id = NULL;
			$department_id = NULL;

			$s_obj = $slf->getScheduleObjectByUserIdAndEpoch( $current_user->getId(), $epoch );
			if ( is_object($s_obj) ) {
				Debug::Text(' Found Schedule!: ', __FILE__, __LINE__, __METHOD__,10);
				$branch_id = $s_obj->getBranch();
				$department_id = $s_obj->getDepartment();
			} else {
				$branch_id = $current_user->getDefaultBranch();
				$department_id = $current_user->getDefaultDepartment();
			}

			$data = array(
							'user_id' => $current_user->getId(),
							'user_full_name' => $current_user->getFullName(),
							'time_stamp' => $epoch,
							'date_stamp' => $epoch,
							'branch_id' => $branch_id,
							'department_id' => $department_id,
							'quantity' => 0,
							'bad_quantity' => 0,
							'status_id' => 10, //In
							'type_id' => 10, //Normal
							'selected_type_option' => (int)Misc::getPointerFromArray( $pf->getOptions('type'), 10 ),
							'selected_status_option' => (int)Misc::getPointerFromArray( $pf->getOptions('status'), 10 ),
							'selected_branch_option' => (int)Misc::getPointerFromArray( $branch_options, $branch_id ),
							'selected_department_option' => (int)Misc::getPointerFromArray( $department_options, $department_id ),

							);

		}

		//Select box options;
		$data['status_options'] = $pf->getOptions('status');
		$data['type_options'] = $pf->getOptions('type');
		$data['branch_options'] = $branch_options;
		$data['department_options'] = $department_options;
		$data['job_options'] = $job_options;
		$data['job_item_options'] = $job_item_options;
		$data['transfer_options'] = $pf->getOptions('transfer');

		//Make sure current station is allowed.
		$station_is_allowed = $current_station->checkAllowed( NULL, NULL, 'WirelessWeb');
		//var_dump($pc_data);

		$smarty->assign_by_ref('data', $data);
		$smarty->assign_by_ref('station_is_allowed', $station_is_allowed);

		break;
}

$smarty->assign_by_ref('result', $result);
$smarty->assign_by_ref('result_str', $result_str);
$smarty->assign_by_ref('pcf', $pcf);
$smarty->assign_by_ref('pf', $pf);

$smarty->display('punch/WAPPunch.tpl');
?>